# Docker
## Wichtigsten CLI-Befehle
```
# Allgemeine Systeminformationen
docker system info

# Anzahl Images, Containers, Local Volumens und Speicherverbrauch
docker system df

# Images verwalten
docker image (ls, pull, push, build, inspect)

# Network verwalten
docker network (ls, create, rm, connect)

# Secrets verwalten
docker secret (ls, create, rm, inspect)

# Volumes verwalten
docker volume (ls, create, inspect, prune, rm)

# Container und Images aufräumen
docker system prune (--all, --force)

# Container Snapshots
docker checkpoint
```
Der Ablageort aller wichtigen Ressourcen von Docker: `/var/lib/docker`.

## Docker Daemon konfigurieren
Unter `/etc/docker/daemon.json` kann distributionsunabhängig eine Konfiguration für den Daemon hinterlegt werden.

Weitere Infos und Vorlage: https://docs.docker.com/config/daemon/

**Empfehlung für Produktivumgebungen:** Devicemapper von `loop-lvm` auf `direct-lvm` umstellen.

## Docker Registry
Es können remote Registries oder eigene verwendet werden.

**Achtung:** Nur von vertrauenswürdigen Quellen/Registries Images laden, da auch Schadcode durch fremd erstellte Images eingeschleust werden können.

### Standard Registry docker.io

Die Standard Registry ist `docker.io` bzw. über den Browser https://hub.docker.com/. Mit dem Befehl `docker search <IMAGENAME>` kann ein Image gesucht und mit `docker pull <IMAGENAME>` geholt werden.

### Eigene Registry
